package ext.cust.toc;

package ..deTemp.1735022429217;

import ext.cust.Const;
import ext.cust.dao.CustomizeOMPTOCDAO;
import ext.cust.generic.util.DateUtil;
import ext.cust.generic.util.GenericUtil;
import ext.cust.generic.util.IBAUtil;
import ext.cust.generic.util.XMLUtil;
import ext.cust.generic.util.ZipUtil;
import ext.cust.service.dataTable.PublishDocViewDataTable;
import ext.cust.sis.PubProcess;
import ext.cust.toc.PTOCUtil;
import ext.cust.toc.PrePublishProcess;
import ext.cust.toc.TOCUtil;
import ext.cust.toc.pojo.Part;
import ext.cust.toc.pojo.TOCEntryExport;
import ext.cust.util.WorkflowUtil;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.dom4j.Document;
import org.dom4j.Element;
import org.dom4j.tree.DefaultAttribute;
import wt.content.ApplicationData;
import wt.content.ContentHelper;
import wt.content.ContentHolder;
import wt.content.ContentItem;
import wt.content.ContentRoleType;
import wt.content.ContentServerHelper;
import wt.content.StandardContentService;
import wt.doc.WTDocument;
import wt.epm.EPMDocument;
import wt.fc.Persistable;
import wt.fc.PersistenceHelper;
import wt.fc.WTObject;
import wt.iba.value.IBAHolder;
import wt.part.WTPart;
import wt.pom.Transaction;
import wt.session.SessionServerHelper;
import wt.util.WTException;
import wt.vc.config.ConfigSpec;
import wt.vc.config.LatestConfigSpec;

public class PushProcess {
  public String pushXMLdata(WTObject pbo) {
    Transaction trans = new Transaction();
    WTDocument publishDoc = (WTDocument)pbo;
    IBAUtil iba = new IBAUtil((IBAHolder)publishDoc);
    Map map = iba.getIBAValues();
    String PubPartNo = (String)map.get("PubPartNo");
    String PartNo = (String)map.get("PartNo");
    String PushDataType = (String)map.get("PushDataType");
    String lang = (String)map.get("SourceLanguage");
    String filename = (String)map.get("ExtFileName");
    String importType = (String)map.get("ImportType");
    String cmmtoc = (String)map.get(Const.IBA_SCMORHOMMTOC);
    System.out.println("-------------:" + map.toString());
    try {
    
    } catch (Exception e) {
      e.printStackTrace();
      return null;
    } finally {
      if (trans != null)
        trans.rollback(); 
    } 
    if (trans != null)
      trans.rollback(); 
    return null;
  }
  
  public static Set<String> FindGIONode(Document doc) throws WTException {
    Element rootEle = doc.getRootElement();
    Set<String> gios = new HashSet<>();
    List<Element> list = rootEle.selectNodes("//graphic");
    for (Iterator<Element> iterator = list.iterator(); iterator.hasNext(); ) {
      Element element = iterator.next();
      gios.add(element.attributeValue("object-id"));
    } 
    return gios;
  }
  
  public String generateXML(WTPart wtpart, String language, String pubParm) {
    boolean enforce = SessionServerHelper.manager.setAccessEnforced(false);
    try {
      System.out.println("-------开始推送XML");
      Set<String> graphics = new HashSet<>();
      List<String> languageList = new ArrayList();
      languageList.add(language);
      System.out.println("-----推送XML toPart开始");
      Part part = TOCUtil.toPart(wtpart, "", true, true, languageList, false, true, false, true, graphics, false, 
          null, false, false);
      System.out.println("-----推送XML toPart结束");
      System.out.println("-----推送XML 开始写入章节号信息");
      List<WTPart> rootWTPart = new ArrayList<>();
      part = TOCUtil.getParentPart(part, wtpart, rootWTPart);
      TOCUtil.getChapterNum(rootWTPart.get(0), part, (ConfigSpec)Const.CS_LATEST, wtpart.getNumber());
      System.out.println("-----推送XML 结束写入章节号信息");
      boolean loadMicroSection = false;
      if (part.getSoftType().equals("wt.part.WTPart|com.patac.TOCItem|com.patac.Publication|com.patac.PTOCSM"))
        loadMicroSection = true; 
      String xmlFileContent = TOCUtil.toXmlForPart(part, language, null, loadMicroSection);
      System.out.println("----推送XML 开始处理CELL LINK");
      Map<Object, Object> allIE = new LinkedHashMap<>();
      TOCUtil.getALLIE(languageList, rootWTPart.get(0), (ConfigSpec)new LatestConfigSpec(), allIE);
      xmlFileContent = dealCellLink(language, xmlFileContent, allIE, pubParm);
      System.out.println("----推送XML 处理CELL LINK结束");
      return xmlFileContent;
    } catch (Exception e) {
      e.printStackTrace();
    } finally {
      SessionServerHelper.manager.setAccessEnforced(enforce);
    } 
    return null;
  }
  
  public String exportPTOCXML(WTPart wtpart, String language, String partno, String pubParm, String importType, String fileExternal, WTDocument doc) throws Exception {
    boolean enforce = SessionServerHelper.manager.setAccessEnforced(false);
    try {
      System.out.println("-------开始推送XML");
      Set<String> graphics = new HashSet<>();
      Set<String> videos = new HashSet<>();
      List<String> languageList = new ArrayList();
      languageList.add(language);
      System.out.println("-----推送XML toPart开始");
      Part part = TOCUtil.toPart(wtpart, "", true, true, languageList, false, true, false, true, graphics, false, 
          null, false, false, true, videos);
      System.out.println("-----推送XML toPart结束");
      System.out.println("-----推送XML 开始写入章节号信息");
      List<WTPart> rootWTPart = new ArrayList<>();
      part = TOCUtil.getParentPart(part, wtpart, rootWTPart);
      TOCUtil.getChapterNum(rootWTPart.get(0), part, (ConfigSpec)Const.CS_LATEST, wtpart.getNumber());
      System.out.println("-----推送XML 结束写入章节号信息");
      boolean loadMicroSection = false;
      if (part.getSoftType().equals("wt.part.WTPart|com.patac.TOCItem|com.patac.Publication|com.patac.PTOCSM"))
        loadMicroSection = true; 
      String xmlFileContent = TOCUtil.toXmlForPart(part, language, null, loadMicroSection);
      System.out.println("----推送XML 开始处理CELL LINK");
      Map<Object, Object> allIE = new LinkedHashMap<>();
      TOCUtil.getALLIE(languageList, rootWTPart.get(0), (ConfigSpec)new LatestConfigSpec(), allIE);
      xmlFileContent = dealCellLink(language, xmlFileContent, allIE, pubParm);
      System.out.println("----推送XML 结束处理CELL LINK");
      String xmlName = part.getNumber();
      String filePath = PTOCUtil.createXmlFile(xmlFileContent, "ExportPTOCXml", xmlName, ".xml");
      File file = new File(filePath);
      String basePath = file.getParentFile().getAbsolutePath();
      Document document = XMLUtil.parseXMLContent(xmlFileContent);
      if (document == null) {
        System.out.println("XML 文件格式或编号不正确");
        return null;
      } 
      Element root = document.getRootElement();
      PubProcess sisServ = new PubProcess();
      if (!"".equals(fileExternal)) {
        String ptocpno = wtpart.getNumber();
        ApplicationData app = GenericUtil.getAttachmentFromDocument(doc, fileExternal);
        if (app != null) {
          InputStream is = ContentServerHelper.service.findContentStream(app);
          sisServ.getMPtocData(ptocpno, language);
          if ("RPO".equals(importType)) {
            List<String> rpoList = sisServ.getRPOListFromFile(is);
            if (rpoList != null && rpoList.size() >= 0)
              sisServ.getSISDatafilterByRpo(rpoList, language, Boolean.valueOf(false)); 
          } else {
            sisServ.getSISDataByExternal(is, language);
          } 
          List<Element> sisLinkList = root.selectNodes(".//servinfosub");
          for (Element ele : sisLinkList) {
            String objectId = ele.attributeValue("object-id");
            Element parent = ele.getParent();
            String oieId = parent.attributeValue("object-id");
            boolean lbExists = false;
            for (int i = 0; i < sisServ.sisData.size(); i++) {
              String sisNO = ((TOCEntryExport)sisServ.sisData.get(i)).getSioNo();
              String oieNo = ((TOCEntryExport)sisServ.sisData.get(i)).getIeNo();
              String sioType = ((TOCEntryExport)sisServ.sisData.get(i)).getSioType();
              if (sioType != null && sioType.equals("SIS"))
                if (sisNO != null)
                  if (sisNO.equals(objectId) && oieNo.equalsIgnoreCase(String.valueOf(oieId) + "_" + language)) {
                    lbExists = true;
                    sisServ.sisData.remove(i);
                    break;
                  }   
            } 
            if (!lbExists)
              parent.remove(ele); 
          } 
        } 
      } 
      PrePublishProcess.removeNoServinfosub(root, "section");
      PrePublishProcess.removeNoServinfosub(root, "subsection");
      PrePublishProcess.removeNoServinfosub(root, "servinfo");
      PrePublishProcess.resort(document);
      System.out.println("----推送XML 开始导出图片");
      String graphicsPath = String.valueOf(basePath) + File.separator + "graphics";
      File gFile = new File(graphicsPath);
      gFile.mkdirs();
      for (String graphic : graphics) {
        EPMDocument graphicDoc = GenericUtil.getEPMDocumentByCADName(graphic);
        if (graphicDoc == null)
          continue; 
        GenericUtil.saveToDir(graphicDoc, graphicsPath);
      } 
      System.out.println("----推送XML 结束导出图片");
      System.out.println("----导出PTOC XML 开始导出视频");
      String videosPath = String.valueOf(basePath) + File.separator + "graphics";
      File videoFile = new File(videosPath);
      videoFile.mkdirs();
      for (String video : videos) {
        EPMDocument videoDoc = GenericUtil.getEPMDocumentByCADName(video);
        System.out.println("导出视频编号：" + video);
        if (videoDoc != null)
          GenericUtil.saveToDir(videoDoc, videosPath); 
      } 
      System.out.println("----导出PTOC XML 结束导出视频");
      String zipPath = file.getParentFile().getParentFile().getAbsolutePath();
      if (!file.exists())
        file.mkdir(); 
      if (zipPath.endsWith(File.separator)) {
        zipPath = String.valueOf(zipPath) + partno + "_" + DateUtil.getDateTimeString() + ".zip";
      } else {
        zipPath = String.valueOf(zipPath) + File.separator + partno + "_" + DateUtil.getDateTimeString() + ".zip";
      } 
      ZipUtil.zipByCmd(basePath, zipPath);
      System.out.println("==============================推送XML end:" + zipPath);
      System.out.println(zipPath);
      String title = "推送数据成功：" + wtpart.getNumber() + " - " + wtpart.getName();
      String path = GenericUtil.getFileUrl(zipPath);
      String content = "请点击<a href='" + path + "'>下载</a>";
      WorkflowUtil.startSendEMAIL((Persistable)wtpart, title, content);
      System.out.println("==============已启动发送流程");
      return zipPath;
    } catch (Exception e) {
      e.printStackTrace();
      String title = "导出PTOC(XML)失败：" + wtpart.getNumber() + " - " + wtpart.getName();
      String content = "对不起，导出失败:" + e.getMessage();
      WorkflowUtil.startSendEMAIL((Persistable)wtpart, title, content);
    } finally {
      SessionServerHelper.manager.setAccessEnforced(enforce);
    } 
    return null;
  }
  
  private String dealCellLink(String language, String xmlFileContent, Map allIE, String pubParm) {
    xmlFileContent = xmlFileContent.replace("x-wc://file=", "");
    if (language.equals("zh_CN")) {
      xmlFileContent = xmlFileContent.replace("</cell-link>、<cell-link", "</cell-link><cell-link");
      xmlFileContent = xmlFileContent.replace("</cell-link>和<cell-link", "</cell-link><cell-link");
      xmlFileContent = xmlFileContent.replace("</cell-link>或<cell-link", "</cell-link><cell-link");
    } 
    Document document = XMLUtil.parseXMLContent(xmlFileContent);
    Element root = document.getRootElement();
    List<Element> cellLinkList = root.selectNodes(".//cell-link");
    List<String> beforeCellID = new ArrayList<>();
    for (Element child : cellLinkList)
      beforeCellID = PTOCUtil.cellLink(allIE, child, beforeCellID); 
    document = PrePublishProcess.dealPubParm(document, pubParm);
    xmlFileContent = XMLUtil.getDocumentXML(document);
    if (language.equals("zh_CN")) {
      xmlFileContent = xmlFileContent.replace("</cell-link><cell-link", "</cell-link>、<cell-link");
      xmlFileContent = xmlFileContent.replace("、、", "").replace("、。", "。");
      xmlFileContent = xmlFileContent.replace("，，", "").replace("，。", "。");
    } 
    return xmlFileContent;
  }
  
  private Document dealCellLink(Document doc) {
    String cellid = "";
    List<Element> refs = doc.selectNodes("//warning-ref|//caution-ref");
    for (int i = 0; i < refs.size(); i++) {
      List<Element> celllinks = ((Element)refs.get(i)).selectNodes("ptxt/cell-link");
      if (celllinks.size() != 0) {
        cellid = ((DefaultAttribute)((Element)celllinks.get(0)).attributes().get(1)).getValue();
        List<Element> sios = doc.selectNodes("//servinfo[@object-id='" + cellid + 
            "']/caution-sio|//servinfo[@object-id='" + cellid + "']/warning-sio");
        if (sios.size() != 0) {
          List elepar = ((Element)refs.get(i)).getParent().content();
          elepar.set(elepar.indexOf(refs.get(i)), sios.get(0));
        } 
      } 
    } 
    String docContent = doc.asXML();
    List<Element> links = doc.selectNodes("//cell-link");
    for (int j = 0; j < links.size(); j++)
      docContent = docContent.replace(((Element)links.get(j)).asXML(), "请参见维修手册 " + ((Element)links.get(j)).getText()); 
    doc = XMLUtil.parseXMLContent(docContent);
    List<Element> section = doc.selectNodes("//section[@secnum='0']");
    List secpar = ((Element)section.get(0)).getParent().content();
    secpar.remove(section.get(0));
    return doc;
  }
  
  public static boolean writeFiletoWTDoc(File file, WTDocument doc) {
    try {
      WTDocument wTDocument = doc;
      ContentHolder contentHolder = ContentHelper.service.getContents((ContentHolder)wTDocument);
      List<Object> contentListForTarget = ContentHelper.getContentListAll(contentHolder);
      for (int i = 0; i < contentListForTarget.size(); i++) {
        ContentItem contentItem = (ContentItem)contentListForTarget.get(i);
        if ("PRIMARY".equals(contentItem.getRole().toString())) {
          ContentServerHelper.service.deleteContent(contentHolder, contentItem);
          break;
        } 
      } 
      ApplicationData appData = ApplicationData.newApplicationData((ContentHolder)doc);
      appData.setRole(ContentRoleType.PRIMARY);
      appData.setFileName(String.valueOf(doc.getName()) + "--" + file.getName());
      String fileName = String.valueOf(doc.getName()) + "--" + file.getName();
      StandardContentService.setFormat(fileName, (ContentItem)appData);
      InputStream is = new FileInputStream(file);
      appData = ContentServerHelper.service.updateContent((ContentHolder)doc, appData, is);
      doc = (WTDocument)PersistenceHelper.manager.refresh((Persistable)doc);
      String version = doc.getVersionIdentifier().getValue();
      String iter = doc.getIterationIdentifier().getValue();
      String versionInfo = String.valueOf(version.toUpperCase()) + iter.toUpperCase();
      System.out.println("**********************writeFiletoWTDoc=" + versionInfo);
      CustomizeOMPTOCDAO.insertBatch(doc);
    } catch (Exception e) {
      e.printStackTrace();
      return false;
    } 
    return true;
  }
  
  public static boolean writeFiletoWTDocByFlexible(File file, WTDocument doc, String head) {
    try {
      WTDocument wTDocument = doc;
      ContentHolder contentHolder = ContentHelper.service.getContents((ContentHolder)wTDocument);
      List<Object> contentListForTarget = ContentHelper.getContentListAll(contentHolder);
      for (int i = 0; i < contentListForTarget.size(); i++) {
        ContentItem contentItem = (ContentItem)contentListForTarget.get(i);
        if ("PRIMARY".equals(contentItem.getRole().toString())) {
          ContentServerHelper.service.deleteContent(contentHolder, contentItem);
          break;
        } 
      } 
      ApplicationData appData = ApplicationData.newApplicationData((ContentHolder)doc);
      appData.setRole(ContentRoleType.PRIMARY);
      appData.setFileName(String.valueOf(head) + "--" + doc.getName() + "--" + file.getName());
      String fileName = String.valueOf(head) + "--" + doc.getName() + "--" + file.getName();
      StandardContentService.setFormat(fileName, (ContentItem)appData);
      InputStream is = new FileInputStream(file);
      appData = ContentServerHelper.service.updateContent((ContentHolder)doc, appData, is);
      doc = (WTDocument)PersistenceHelper.manager.refresh((Persistable)doc);
      String version = doc.getVersionIdentifier().getValue();
      String iter = doc.getIterationIdentifier().getValue();
      String versionInfo = String.valueOf(version.toUpperCase()) + iter.toUpperCase();
      System.out.println("**********************writeFiletoWTDoc=" + versionInfo);
      CustomizeOMPTOCDAO.insertBatch(doc);
    } catch (Exception e) {
      e.printStackTrace();
      return false;
    } 
    return true;
  }
  
  public static List<PublishDocViewDataTable> getAllPublishDoc(String oid) {
    return null;
  }
}
